# --------------------------------------------------------------------
# --- %AVAIL TEMPLATE
# --------------------------------------------------------------------
{
my $header = <<'END';

  List of areas, available for forward requesting:
END
my $tbl_hdr = <<'END';

  Fileecho       Description                                  
  ---------------------------------------------------------------------------
END
my $grp_hdr = <<'END';

       @|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
` "..::[ From $link ]::.." '
END
my $tbl_rec = <<'END';
  @<<<<<<<<<<<<< @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
` $tag, $descr '
END
my $tbl_ftr = <<'END';
  ---------------------------------------------------------------------------
END
my $totals = <<'END';
  %d fileecho(s)
' $total `
END
my $empty = <<'END';

  There're no fileechos, available for forward requesting
END
my $denied = <<'END';

  Sorry, but you have no permission to do forward requests
END
my $footer = <<'END';

--- %s %s
'$::PRG_NAME, $::PRG_VER`
 * Origin: use %HELP for help using the AreaMgr in ffix (%s)
'$Tpl::aka`
END

# --------------------------------------------------------------------
#     variables used:
# $Tpl::aka		my aka (string)
# @Tpl::avail		array: 'addr'=>string addr, 'list'=>[tag, descr]
# $Tpl::allowed		1 if allowed to do forward-reqs, 0 otherwise
#     result is returned in @Tpl::res

my $s, $h, $a;
local ($link, $tag, $descr, $total);

@Tpl::res = ();
$s .= tpl2s($header);
if ($Tpl::allowed) {
  if (@Tpl::avail > 0) {
    $s .= tpl2s($tbl_hdr); 
    $total = 0;
    foreach $h (@Tpl::avail) {
      $link = $h->{'addr'};
      if ( ! @{$h->{'list'}} ) { next; }
      $s .= tpl2s($grp_hdr);
      foreach $a (@{$h->{'list'}}) {
        ($tag, $descr) = @$a;
        $total++;
        $s .= tpl2s($tbl_rec);
        # split
        if ( (defined $::config{'split_mail'}) && 
             (length $s > $::config{'split_mail'}) &&
             ($h->{'list'}[-1][0] ne $a) ) {
          $s .= tpl2s($tbl_ftr);
          $s .= tpl2s($footer);
          push @Tpl::res, $s;
          $s = tpl2s($tbl_hdr);
        }
        # /split
      }
    }
    $s .= tpl2s($tbl_ftr);
    $s .= tpl2s($totals);
  }
  else { $s .= tpl2s($empty); }
}
else { $s .= tpl2s($denied); }
$s .= tpl2s($footer);

push @Tpl::res, $s;
return join('', @Tpl::res);
#$s;

}
