# --------------------------------------------------------------------
# --- FILES.BBS FILE TEMPLATE
# --------------------------------------------------------------------
{
  package main;
# one-file description, can be multi-line (see below)
my $tpl = <<'END';
@<<<<<<<<<<< @<<<< @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
` uc $Tpl::info{name}, sprintf("[%03d]", $save[0]+0), first_line $Tpl::info{ldesc} '
                   @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
` rest_lines $Tpl::info{ldesc} '
                      @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
` "(AREA: $Tpl::info{area})" '
END
# one-file mask (RegExp) to find existing records (see below)
my $tpl_mask = <<'END';
@<<<<<<<<<<< \[(\d+)\] .*
` uc $Tpl::info{name} '
                   .*~~
END
# --- IMPORTANT NOTICE:
# 1) in $tpl_mask you can use save-patterns, they are saved while matching
#    and can later be used as @save in $tpl - so you can preserve some data
#    in file descriptions while updating (e.g., download counters)
# 2) ~~ at the end of line in $tpl_mask will be expanded to match 0, 1 or
#    more such lines (i.e., <line>~~ -> (<line>\n)* in RegExp)
# 3) you can use some already defined functions:
#    * first_word(string) - get first word of string
#    * last_word(string)  - get last word of string
#    * first_line(string) - get first line (till \n)
#    * rest_lines(string) - get all lines except first (\n-separated)
# --------------------------------------------------------------------
#     variables used:
# $Tpl::file		path+name of FILES.BBS file
# %Tpl::info		file information structure
# $Tpl::del		if set to 1, delete file description
local (@save);
my ($s, $sm);

  # read FILES.BBS
  if (open F, "$Tpl::file") {
    read F, $_, -s F;
    close F;
  } else { $_ = ''; }
  # create mask
  $sm = tpl2s($tpl_mask); chomp $sm;
  $sm =~ s/^(.*?)~~$/($1\n)*/gm;
  # do replace
  undef @save;
  if ( @save = /$sm/ ) {
    $s = (!$Tpl::del) ? tpl2s($tpl) : '';
    s/$sm/$s/m;
  } 
  # do add
  elsif (!$Tpl::del) { $_ .= tpl2s($tpl); }
  # save FILES.BBS
  if (open F, ">$Tpl::file") {
    print F $_;
    close F;
  }
}
