# --------------------------------------------------------------------
# --- LIST TEMPLATE
# --------------------------------------------------------------------
{
my $header = <<'END';

  The following is a list of %s fileechos and your access level:
'$Tpl::type`
END
my $tbl_hdr = <<'END';

  Fileecho      Description                                  Avg Kb Avg Files
  ---------------------------------------------------------------------------
END
my $grp_hdr = <<'END';
       @|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
` "..::[ Group $cgrp - $::config{group}{$cgrp} ]::.." '
END
my $tbl_rec = <<'END';
 @<<<<<<<<<<<<< @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< @>>>>> @>>>>>>>>
` $mode.$tag, $::areas{$tag}{descr}, $kb, $files'
END
my $tbl_ftr = <<'END';
  ---------------------------------------------------------------------------
END
my $totals = <<'END';
  %d fileecho(s)
' scalar @Tpl::areas `

"+"  You are connected to the fileecho and both send and receive files.
"<"  You are connected to the fileecho and only receive files from our system.
">"  You are connected to the fileecho and only send files to our system.
"-"  You do not have access to the fileecho.
" "  You are not connected to the fileecho.
END
my $empty = <<'END';
  You are not connected to any fileechos
END
my $footer = <<'END';

--- %s %s
'$::PRG_NAME, $::PRG_VER`
 * Origin: use %HELP for help using the AreaMgr in ffix (%s)
'$Tpl::aka`
END

# --------------------------------------------------------------------
#     variables used:
# @Tpl::node		node, to which list is generated
# $Tpl::type		type of list (all, linked, unlinked, avail)
# $Tpl::aka		my aka (string)
# @Tpl::areas		list of areas to display
# $Tpl::empty		string to send if list is empty
#     result is returned in @Tpl::res

my $s;
local ($mode, $kb, $files, $cgrp, $trf);

$s .= tpl2s($header);
if (@Tpl::areas > 0) {
  # sorting by group and tag
  @Tpl::areas = sort { 
                       ($areas{$a}{'group'} eq $areas{$b}{'group'}) ? 
                         ($a cmp $b) : 
                         ($areas{$a}{'group'} cmp $areas{$b}{'group'});
                     } @Tpl::areas;
  # output
  $s .= tpl2s($tbl_hdr);
  foreach $tag (@Tpl::areas) {
    # group
    if ( $cgrp ne $areas{$tag}{'group'}  ) {
      $cgrp = $areas{$tag}{'group'};
      $s .= tpl2s($grp_hdr);
    }
    # mode
    $mode = area_node($areas{$tag}, \@Tpl::node);
    $mode =~ s/[*]//;
    if (!defined $mode) { $mode = area_avail($tag, \@Tpl::node) ? ' ' : '-'; }
    elsif ($mode eq '') { $mode = '+'; }
    else { $mode =~ tr/<>/></; }
    # traffic
    $kb = $files = '?';
    $trf = ::update_traffic($tag);
    if ( defined $trf ) {
      $kb = $trf->{'cmk'};
      if ($trf->{'lmk'} >= 0) { $kb = $kb/2 + $trf->{'lmk'}/2; }
      $files = $trf->{'cmf'};
      if ($trf->{'lmf'} >= 0) { $files = $files/2 + $trg->{'lmf'}/2; }
      $kb = int($kb/1024);
    }
    $s .= tpl2s($tbl_rec);
    # split
    if ( (defined $::config{'split_mail'}) && 
         (length $s > $::config{'split_mail'}) &&
         ($Tpl::areas[-1] ne $tag)) {
      $s .= tpl2s($tbl_ftr);
      $s .= tpl2s($footer);
      push @Tpl::res, $s;
      $s = tpl2s($tbl_hdr);
    }
    # /split
  }
  $s .= tpl2s($tbl_ftr).tpl2s($totals);
}
else { $s .= "\n".$Tpl::empty."\n"; }
$s .= tpl2s($footer);
push @Tpl::res, $s;
return join('', @Tpl::res);
#$s;

}
