# --------------------------------------------------------------------
# --- DAILY REPORT TEMPLATE
# --------------------------------------------------------------------
{
my $header = <<'END';

 Today, %s, %s received the following files
'POSIX::strftime("%A, %d %B %Y", localtime), addr2s @{$Tpl::aka}`

.
END
my $area_hdr = <<'END';
 Area : @<<<<<<<<<<<<<<<<<<< Comment : @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
`$area, $::areas{$area}{descr}'
 -----------------------------------------------------------------------------
END
my $area_ftr = <<'END';
 -----------------------------------------------------------------------------
 %11d bytes in %d file(s)
'$cnt_bytes, $cnt_files`

.
END
my $file_hdr = <<'END';
 @<<<<<<<<<<< @>>>>>>>>> @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
`$file{file}, $file{size}, $file{ldesc}'
END
my $totals = <<'END';
 Total %d bytes in %d file(s)
'$tot_bytes, $tot_files`

Thanks!
END
my $footer = <<'END';

--- %s %s
'$::PRG_NAME, $::PRG_VER`
 * Origin: %s (%s)
' $::config{origin}, addr2s @{$Tpl::aka} `
END

# --------------------------------------------------------------------
#     variables used:
# $Tpl::aka		aka used (\@addr)
# @Tpl::areas		list of areas
# %Tpl::files		hash of area=>[files], files - array of fileinfo structures
# $Tpl::force		if 0, don't out empty report
#     result is returned in @Tpl::res

my $s;
local ($tot_bytes, $tot_files, $cnt_bytes, $cnt_files, $area, %file);

$s .= tpl2s($header);
$tot_bytes = $tot_files = 0;
foreach $area (@Tpl::areas) {
  $s .= tpl2s($area_hdr);
  $cnt_files = $cnt_bytes = 0;
  foreach my $f (@{$Tpl::files{$area}}) {
    %file = %$f;
    $cnt_files++; $cnt_bytes += $file{'size'};
    $tot_files++; $tot_bytes += $file{'size'};
    $s .= tpl2s($file_hdr);
  }
  $s .= tpl2s($area_ftr);
  # split
  if ( (defined $::config{'split_echo'}) && 
       (length $s > $::config{'split_echo'}) &&
       ($Tpl::areas[-1] ne $area)) {
    $s .= tpl2s($footer);
    push @Tpl::res, $s;
    $s = tpl2s($header);
  }
  # /split
}
$s .= tpl2s($totals).tpl2s($footer);
push @Tpl::res, $s;

if ($Tpl::force || $tot_files) { return $s = join('', @Tpl::res); } 
else { undef $s; undef @Tpl::res; return undef; }

}
